<?php

/********************************************************************
 *
 * 設定保存処理
 * 　　POST :　設定画面のフォーム内容
 *
 ********************************************************************/

//共通処理呼び出し
$require_login = true; //ログイン必要
$no_entry_check = true;
$no_nsfw_check = true;
require_once("../common.php");

//入力チェック
$site_title = filter_input(INPUT_POST, 'site_title');
$display_name = filter_input(INPUT_POST, 'display_name');
$image_color = filter_input(INPUT_POST, 'image_color');
if (!$site_title || !$display_name || !$image_color) {
    //必須項目なし
    echo ('{"status":"error","message":"必須項目が指定されていません"}');
    exit;
}

// POSTされたデータを取得
$post_data = $_POST;
$post_data['instruction_text'] =  base64_decode($post_data['instruction_text']); //WAF対策
$post_data['entry_text'] =  base64_decode($post_data['entry_text']); //WAF対策

//画像登録
fileCopy('ogimage_file', '../images/ogimage.jpg');
fileCopy('banner_file', '../images/banner.jpg');
fileCopy('icon_file', '../images/usericon.jpg');
fileCopy('favicon_file', '../images/userfavicon.png');
fileCopy('mini_banner_file', '../images/mini_banner.png');

//DEMO版対応
if ($DEMO_MODE) {
    echo '{"status":"error","message":"デモ環境では環境設定は変更できません"}';
    return;

    //説明文からリンク、スクリプトを除去
    $comment = $post_data['instruction_text'];
    $comment = preg_replace('/<.*?a .*?>/i', "", $comment);
    $comment = preg_replace('/<.*?script.*?>/i', "", $comment);
    $comment = preg_replace('/<.*?iframe.*?>/i', "", $comment);
    $comment = preg_replace('/action=/i', "", $comment);
    $post_data['instruction_text']  = $comment;

    //エントリーモードは使用不可
    $post_data['use_entry'] = false;
    $post_data['entry_password'] = "";
    $post_data['entry_text'] = "※デモ環境ではエントリーページは使用できません";
}

try {
    $db->exec("begin  Immediate");

    // settingsテーブルに登録されているフィールド名を取得
    $result = $db->query('SELECT * FROM setting LIMIT 1');
    $row = $result->fetchArray(SQLITE3_ASSOC);
    $fields = array_keys($row); //フィールド名の一覧を取得

    // データを更新するSQL文を作成
    $sql = "UPDATE setting SET ";
    foreach ($post_data as $key => $value) {
        // name項目と一致するフィールド名があれば、SQL文にデータを追加
        if (in_array($key, $fields)) {
            $sql .= $key . "= :" . $key . ",";
        }
    }
    $sql = rtrim($sql, ',');

    // データ設定
    $stmt = $db->prepare($sql);
    foreach ($post_data as $key => $value) {
        // name項目と一致するフィールド名があれば、bindValueで値を設定
        if (in_array($key, $fields)) {
            $stmt->bindValue(':' . $key, $value);
        }
    }
    $stmt->execute();

    //SNSリンク
    if (!$DEMO_MODE) {
        $accounts = array();
        for ($i = 0; $i < count($_POST['sns_id']); $i++) {
            $id = filter_var($_POST['sns_id'][$i], FILTER_VALIDATE_INT);
            $url = filter_var($_POST['sns_url'][$i]) ?? "";
            $icon = filter_var($_POST['sns_icon'][$i]) ?? "";
            if ($id) {
                $accounts[] = array(
                    'id' => $id,
                    'url' => $url,
                    'icon' => $icon
                );
            }
        }
        for ($i = 0; $i < count($_FILES["sns_icon_upload"]['tmp_name']); $i++) {
            if (is_uploaded_file($_FILES["sns_icon_upload"]['tmp_name'][$i])) {

                $is_jpeg = preg_match('/\.(jpe?g|jfif|pjpeg|pjp)$/i', $_FILES["sns_icon_upload"]['name'][$i]);
                $is_png = preg_match('/\.(png)$/i', $_FILES["sns_icon_upload"]['name'][$i]);
                if ($is_png) {
                    //pngの場合はそのままコピー
                    $copy = "../images/sns$i.png";
                    $accounts[$i]['icon'] = $PATH_INFO["url_system_root"] . "/images/sns$i.png";
                    copy($_FILES["sns_icon_upload"]['tmp_name'][$i], $copy);
                } else if ($is_jpeg) {
                    //Jpegの場合はそのままコピー
                    $copy = "../images/sns$i.jpg";
                    $accounts[$i]['icon'] = $PATH_INFO["url_system_root"] . "/images/sns$i.jpg";
                    copy($_FILES["sns_icon_upload"]['tmp_name'][$i], $copy);
                } else {
                    $copy = "../images/sns$i.jpg";
                    $accounts[$i]['icon'] = $PATH_INFO["url_system_root"] . "/images/sns$i.jpg";
                    $imageData = file_get_contents($_FILES["sns_icon_upload"]['tmp_name'][$i]);
                    imagejpeg(imagecreatefromstring($imageData), $copy, 100);
                }
            }
        }

        foreach ($accounts as $account) {
            $sql = "INSERT OR REPLACE INTO accounts(id, url, icon) VALUES(:id, :url, :icon)";
            $stmt = $db->prepare($sql);
            $stmt->bindParam(':id', $account['id'], SQLITE3_INTEGER);
            $stmt->bindParam(':url', $account['url'], SQLITE3_TEXT);
            $stmt->bindParam(':icon', $account['icon'], SQLITE3_TEXT);
            $stmt->execute();
        }

        //SNS指定が最後までいっていたら1行追加
        if ($_POST['sns_url'][count($_POST['sns_id']) - 1]) {
            $db->exec("INSERT INTO accounts(url,icon) VALUES('','')");
        }
    }
    $db->exec("commit");
} catch (Exception $ex) {
    http_response_code(500);
    echo '{"status":"error","message":"' . $ex->getMessage() . '"}';
} finally {
    $db->close();
}
if ($db->lastErrorCode() !== 0) {
    http_response_code(500);
    echo '{"status":"error", "message": "' .  $db->lastErrorMsg()  . '"}';
} else {
    echo '{"status":"success"}';
}

function fileCopy($file, $copy)
{
    if (isset($_FILES[$file]) && is_uploaded_file($_FILES[$file]['tmp_name'])) {
        $is_jpeg = preg_match('/\.(jpe?g|jfif|pjpeg|pjp)$/i', $_FILES[$file]['name']);
        if ($is_jpeg) {
            //Jpegの場合はそのままコピー
            copy($_FILES[$file]['tmp_name'], $copy);
        } else {
            $imageData = file_get_contents($_FILES[$file]['tmp_name']);
            imagejpeg(imagecreatefromstring($imageData), $copy, 100);
        }
    }
}
