<?php

//ユーザー作成のpluginは /env/plugin フォルダ内に配置してください

namespace plugin_comment_validate {
    //コメント送信時のバリデート処理を記述します。
    //NGの際は 
    // die('{"status":"error","message":"送信できません"}');
    // die('{"status":"success","message":"コメントを送信しました"}');
    // のような形でdieしてください
    // 
    // $formsには "name","comment","email","success_message" が渡されます
    function validate($forms)
    {
        // SPAMチェック
        // この一覧に含まれるワードがメール本文に含まれている場合送信されません
        $spam_words = array(
            'spam',
            'viagra',
            'cialis',
            'online pharmacy',
            'online casino',
            'weight loss',
            'earn money',
            'free money',
            'investment opportunity',
            'get rich quick',
            'limited time offer',
            'work from home',
            'credit score',
            'debt relief',
            'mortgage rates',
            'insurance rates',
            'pre-approved',
            'meet singles',
            'adult content',
            'porn',
            'gambling',
            'online gambling',
            'payday loan',
            'student loan',
            'diploma',
            'オンラインカジノ',
            'バイアグラ',
            'シアリス',
            '借金返済',
            'お金儲け',
            'アダルト',
            '出会い系',
            '無料体験',
            'キャッシング',
            'クレジットカード',
            '投資情報',
            '住宅ローン',
            '保険',
            '資格取得',
            'お金稼ぎ',
            '副業',
            '在宅ワーク',
            '激安',
            'セール',
            '限定',
            'プレゼント',
            '無料配布',
            'ポイント還元',
            'キャンペーン',
            '高収入',
            '確実',
            '即金',
            '募集',
            '闇バイト'
        );
        $comment = $forms["comment"];
        foreach ($spam_words as $spam_word) {
            if (strpos($comment, $spam_word) !== false) {
                //失敗にしたい場合
                die('{"status":"error","message":"NGワードが含まれているため送信できません"}');

                //成功に見せかけたい場合
                //die('{"status":"error","message":"' . $forms['success_message'] . '"}');
            }
        }

        // IPアドレスチェック
        // この一覧に含まれるIPアドレスの場合送信されません
        // * 指定で0～255がターゲットになります
        $spam_ips = array(
            '192.168.230.*',
            '192.168.220.5',
        );

        $ip = $_SERVER['REMOTE_ADDR'];
        foreach ($spam_ips as $spam_ip) {
            $pattern = '/^' . str_replace('*', '[0-9]+', str_replace('.', '\.', $spam_ip)) . '$/';
            if (preg_match($pattern, $ip)) {
                //失敗にしたい場合
                die('{"status":"error","message":"送信できません"}');

                //成功に見せかけたい場合
                //die('{"status":"error","message":"' . $forms['success_message'] . '"}');
            }
        }
    }
}
